Index: palm/trunk/SOURCE/lagrangian_particle_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/lagrangian_particle_model_mod.f90	(revision 4777)
+++ palm/trunk/SOURCE/lagrangian_particle_model_mod.f90	(revision 4778)
@@ -24,4 +24,7 @@
 ! -----------------
 ! $Id$
+! output of particle time series added
+!
+! 4731 2020-10-07 13:25:11Z schwenkel
 ! Move exchange_horiz from time_integration to modules
 !
@@ -209,4 +212,12 @@
     USE cpulog,                                                                                    &
         ONLY:  cpu_log, log_point, log_point_s
+
+    USE data_output_particle_mod,                                                                  &
+        ONLY:  dop_active,                                                                         &
+               dop_finalize,                                                                       &
+               dop_init,                                                                           &
+               dop_output_tseries,                                                                 &
+               dop_prt_axis_dimension,                                                             &
+               dop_last_active_particle
 
     USE indices,                                                                                   &
@@ -266,8 +277,4 @@
                surf_lsm_h,                                                                         &
                surf_usm_h
-
-!-- Next lines are in preparation for the output of particle data
-!    USE data_output_particle_mod,                                              &
-!        ONLY:  dop_active, dop_init, dop_output_tseries
 
 #if defined( __parallel )
@@ -326,4 +333,5 @@
     INTEGER(iwp) ::  trnp_count_sum                               !< parameter for particle exchange of PEs
 
+    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE ::  id_counter !< number of particles initialized in each grid box
     INTEGER(isp), DIMENSION(:,:,:), ALLOCATABLE ::  seq_random_array_particles   !< sequence of random array for particle
 
@@ -410,20 +418,21 @@
     PRIVATE
 
-    PUBLIC lpm_parin,                                                                              &
-           lpm_header,                                                                             &
-           lpm_init_arrays,                                                                        &
-           lpm_init,                                                                               &
-           lpm_actions,                                                                            &
+    PUBLIC lagrangian_particle_model
+
+    PUBLIC lpm_actions,                                                                            &
+           lpm_check_parameters,                                                                   &
            lpm_data_output_ptseries,                                                               &
            lpm_exchange_horiz_bounds,                                                              &
+           lpm_header,                                                                             &
+           lpm_init,                                                                               &
            lpm_interaction_droplets_ptq,                                                           &
+           lpm_init_arrays,                                                                        &
+           lpm_last_actions,                                                                       &
+           lpm_parin,                                                                              &
+           lpm_rrd_global,                                                                         &
+           lpm_rrd_local,                                                                          &
            lpm_rrd_local_particles,                                                                &
-           lpm_wrd_local,                                                                          &
-           lpm_rrd_global,                                                                         &
            lpm_wrd_global,                                                                         &
-           lpm_rrd_local,                                                                          &
-           lpm_check_parameters
-
-    PUBLIC lagrangian_particle_model
+           lpm_wrd_local
 
     INTERFACE lpm_check_parameters
@@ -533,4 +542,8 @@
        MODULE PROCEDURE dealloc_particles_array
     END INTERFACE dealloc_particles_array
+
+    INTERFACE lpm_last_actions
+       MODULE PROCEDURE lpm_last_actions
+    END INTERFACE lpm_last_actions
 
     INTERFACE lpm_sort_and_delete
@@ -629,4 +642,5 @@
        collision_kernel,                                                                           &
        curvature_solution_effects,                                                                 &
+       data_output_pts,                                                                            &
        deallocate_memory,                                                                          &
        density_ratio,                                                                              &
@@ -651,7 +665,7 @@
        particle_advection_interpolation,                                                           &
        particle_maximum_age,                                                                       &
-       part_output,                                                                                &
-       part_inc,                                                                                   &
-       part_percent,                                                                               &
+       pts_id_file,                                                                                &
+       pts_increment,                                                                              &
+       pts_percentage,                                                                             &
        pdx,                                                                                        &
        pdy,                                                                                        &
@@ -861,4 +875,6 @@
  SUBROUTINE lpm_check_parameters
 
+    LOGICAL ::  id_file_exists = .FALSE.
+
 !
 !-- Collision kernels:
@@ -880,4 +896,5 @@
 
     END SELECT
+
     IF ( collision_kernel(6:9) == 'fast' )  use_kernel_tables = .TRUE.
 
@@ -897,7 +914,33 @@
        message_string = 'nested runs in combination with cloud droplets ' //                       &
                         'is not implemented'
-          CALL message( 'lpm_check_parameters', 'PA0687', 1, 2, 0, 6, 0 )
+       CALL message( 'lpm_check_parameters', 'PA0687', 1, 2, 0, 6, 0 )
     ENDIF
 
+    IF ( pts_increment > 1  .AND.  pts_percentage < 100.0_wp )  THEN
+       message_string = 'pts_increment and pts_percentage cannot be set both '
+       CALL message( 'lpm_check_parameters', 'PA0...', 1, 2, 0, 6, 0 )
+    ENDIF
+
+    IF ( pts_increment < 1 )  THEN
+       message_string = 'pts_increment must be > 1'
+       CALL message( 'lpm_check_parameters', 'PA0...', 1, 2, 0, 6, 0 )
+    ENDIF
+
+    IF ( pts_percentage > 100.0_wp )  THEN
+       message_string = 'pts_percentage must be < 100'
+       CALL message( 'lpm_check_parameters', 'PA0...', 1, 2, 0, 6, 0 )
+    ENDIF
+
+    INQUIRE( FILE = pts_id_file, EXIST = id_file_exists )
+#if defined( __netcdf4_parallel )
+!
+!-- Check if individual particles timeseries is set
+    IF ( pts_increment  > 1  .AND.  dt_dopts /= 9999999.9_wp  .OR.                                 &
+         pts_percentage < 100.0_wp  .AND.  dt_dopts /= 9999999.9_wp  .OR.                          &
+         id_file_exists  .AND.  dt_dopts /= 9999999.9_wp  )                                        &
+    THEN
+       dop_active = .TRUE.
+    ENDIF
+#endif
 
  END SUBROUTINE lpm_check_parameters
@@ -948,4 +991,6 @@
     INTEGER(iwp) ::  j                           !<
     INTEGER(iwp) ::  k                           !<
+
+    LOGICAL  ::  read_restart                    !<
 
     REAL(wp) ::  div                             !<
@@ -1229,13 +1274,17 @@
 !-- For the first model run of a possible job chain initialize the particles, otherwise read the
 !-- particle data from restart file.
+    read_restart = .FALSE.
     IF ( TRIM( initializing_actions ) == 'read_restart_data'                                       &
          .AND.  read_particles_from_restartfile )  THEN
        CALL lpm_rrd_local_particles
+
+       read_restart = .TRUE.
     ELSE
 !
 !--    Allocate particle arrays and set attributes of the initial set of particles, which can be
 !--    also periodically released at later times.
-       ALLOCATE( prt_count(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                         &
-                 grid_particles(nzb+1:nzt,nys:nyn,nxl:nxr) )
+       ALLOCATE( grid_particles(nzb+1:nzt,nys:nyn,nxl:nxr),                                        &
+                 id_counter(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                        &
+                 prt_count(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
 
        number_of_particles = 0
@@ -1243,5 +1292,5 @@
 !
 !--    Initialize counter for particle IDs
-       grid_particles%id_counter = 1
+       id_counter = 1
 !
 !--    Initialize all particles with dummy values (otherwise errors may occur within restart runs).
@@ -1314,6 +1363,8 @@
 
 !
-!-- next line is in preparation for particle data output
-!    CALL dop_init
+!-- Output of particle time series
+    IF ( dop_active )  THEN
+       CALL dop_init( read_restart )
+    ENDIF
 
 !
@@ -1520,5 +1571,5 @@
     prt_count   = local_count
 !
-!-- Calculate particle IDs
+!-- Calculate particle IDs (for new particles only)
     DO  ip = nxl, nxr
        DO  jp = nys, nyn
@@ -1527,15 +1578,13 @@
              IF ( number_of_particles <= 0 )  CYCLE
              particles => grid_particles(kp,jp,ip)%particles(1:number_of_particles)
-
-             DO  n = local_start(kp,jp,ip), number_of_particles  !only new particles
-
-                particles(n)%id = 10000_idp**3 * grid_particles(kp,jp,ip)%id_counter +             &
-                                  10000_idp**2 * kp + 10000_idp * jp + ip
+             DO  n = local_start(kp,jp,ip), number_of_particles
+
+                particles(n)%id = 10000_idp**3 * id_counter(kp,jp,ip) + 10000_idp**2 * kp +        &
+                                  10000_idp * jp + ip
 !
 !--             Count the number of particles that have been released before
-                grid_particles(kp,jp,ip)%id_counter = grid_particles(kp,jp,ip)%id_counter + 1
+                id_counter(kp,jp,ip) = id_counter(kp,jp,ip) + 1
 
              ENDDO
-
           ENDDO
        ENDDO
@@ -2682,4 +2731,8 @@
     CALL cpu_log( log_point(36), 'data_output_ptseries', 'start' )
 
+    IF ( dop_active )  THEN
+       CALL dop_output_tseries
+    ENDIF
+
     IF ( myid == 0 )  THEN
 !
@@ -3052,8 +3105,9 @@
        FLUSH(9)
 
-       ALLOCATE( prt_count(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                         &
-                 grid_particles(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-
-       ALLOCATE( prt_global_index(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+       ALLOCATE( grid_particles(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                    &
+                 id_counter(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                        &
+                 prt_count(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                         &
+                 prt_global_index(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+
 !
 !--    Open restart file for read, if not already open, and do not allow usage of shared-memory I/O
@@ -3068,4 +3122,5 @@
 
        prt_count = 0
+       CALL rrd_mpi_io( 'id_counter', id_counter )
        CALL rrd_mpi_io( 'prt_count', prt_count )
        CALL rrd_mpi_io( 'prt_global_index', prt_global_index )
@@ -3147,10 +3202,18 @@
     LOGICAL, INTENT(OUT)  ::  found
 
-    REAL(wp), DIMENSION(nzb:nzt+1,nys_on_file-nbgp:nyn_on_file+nbgp,nxl_on_file-nbgp:nxr_on_file+nbgp) ::  tmp_3d   !<
-
+    REAL(wp), DIMENSION(nzb:nzt+1,nys_on_file-nbgp:nyn_on_file+nbgp,nxl_on_file-nbgp:nxr_on_file+nbgp) ::  tmp_3d          !<
+    INTEGER(iwp), DIMENSION(nzb:nzt+1,nys_on_file-nbgp:nyn_on_file+nbgp,nxl_on_file-nbgp:nxr_on_file+nbgp) ::  tmp_3d_int  !<
 
     found = .TRUE.
 
     SELECT CASE ( restart_string(1:length) )
+
+        CASE ( 'id_counter' )
+           IF ( .NOT. ALLOCATED( id_counter ) )  THEN
+              ALLOCATE( id_counter(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+           ENDIF
+           IF ( k == 1 )  READ ( 13 )  tmp_3d_int
+           id_counter(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =                                 &
+              tmp_3d_int(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
         CASE ( 'pc_av' )
@@ -3349,4 +3412,8 @@
 #endif
 
+       IF ( ALLOCATED( id_counter ) )  THEN
+          CALL wrd_write_string( 'id_counter' )
+          WRITE ( 14 )  id_counter
+       ENDIF
 
        IF ( ALLOCATED( seq_random_array_particles ) )  THEN
@@ -3355,7 +3422,5 @@
        ENDIF
 
-
     ELSEIF ( restart_data_format_output(1:3) == 'mpi' )  THEN
-
 
        IF ( ALLOCATED( seq_random_array_particles ) )  THEN
@@ -3396,5 +3461,6 @@
        ENDIF
 
-       CALL wrd_mpi_io( 'prt_count', prt_count )
+       CALL wrd_mpi_io( 'id_counter', id_counter )
+       CALL wrd_mpi_io( 'prt_count',  prt_count )
 
        start_index = start_index_on_pe
@@ -3437,4 +3503,10 @@
        WRITE ( 14 )  curvature_solution_effects
 
+       CALL wrd_write_string( 'dop_last_active_particle' )
+       WRITE ( 14 )  dop_last_active_particle
+
+       CALL wrd_write_string( 'dop_prt_axis_dimension' )
+       WRITE ( 14 )  dop_prt_axis_dimension
+
        CALL wrd_write_string( 'interpolation_simple_corrector' )
        WRITE ( 14 )  interpolation_simple_corrector
@@ -3459,4 +3531,6 @@
        CALL wrd_mpi_io( 'bc_par_ns', bc_par_ns )
        CALL wrd_mpi_io( 'bc_par_t', bc_par_t )
+       CALL wrd_mpi_io( 'dop_last_active_particle', dop_last_active_particle )
+       CALL wrd_mpi_io( 'dop_prt_axis_dimension', dop_prt_axis_dimension )
        CALL wrd_mpi_io( 'last_particle_release_time', last_particle_release_time )
        CALL wrd_mpi_io( 'number_of_particle_groups', number_of_particle_groups )
@@ -3508,4 +3582,10 @@
           READ ( 13 )  curvature_solution_effects
 
+       CASE ( 'dop_last_active_particle' )
+          READ ( 13 )  dop_last_active_particle
+
+       CASE ( 'dop_prt_axis_dimension' )
+          READ ( 13 )  dop_prt_axis_dimension
+
        CASE ( 'interpolation_simple_corrector' )
           READ ( 13 )  interpolation_simple_corrector
@@ -3551,4 +3631,6 @@
     CALL rrd_mpi_io( 'bc_par_ns', bc_par_ns )
     CALL rrd_mpi_io( 'bc_par_t', bc_par_t )
+    CALL rrd_mpi_io( 'dop_prt_axis_dimension', dop_prt_axis_dimension )
+    CALL rrd_mpi_io( 'dop_last_active_particle', dop_last_active_particle )
     CALL rrd_mpi_io( 'last_particle_release_time', last_particle_release_time )
     CALL rrd_mpi_io( 'number_of_particle_groups', number_of_particle_groups )
@@ -3577,4 +3659,20 @@
 
  END SUBROUTINE lpm_rrd_global_mpi
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Last actions before PALM finishes.
+!------------------------------------------------------------------------------!
+ SUBROUTINE lpm_last_actions
+
+!
+!-- Close NETCDF file for individual particle timeseries
+    IF ( dop_active )  THEN
+       CALL dop_finalize
+    ENDIF
+
+ END SUBROUTINE lpm_last_actions
 
 
Index: palm/trunk/SOURCE/mod_particle_attributes.f90
===================================================================
--- palm/trunk/SOURCE/mod_particle_attributes.f90	(revision 4777)
+++ palm/trunk/SOURCE/mod_particle_attributes.f90	(revision 4778)
@@ -24,4 +24,7 @@
 ! -----------------
 ! $Id$
+! variables for particle output renamed, id counter removed from particle type
+!
+! 4677 2020-09-14 07:55:28Z raasch
 ! file re-formatted to follow the PALM coding standard
 !
@@ -60,5 +63,6 @@
     INTEGER(iwp), PARAMETER ::  max_number_of_particle_groups = 10 !< maximum allowed number of particle groups
 
-    CHARACTER(LEN=varnamelength), DIMENSION(50) ::  part_output = ' '  !< namelist parameter
+    CHARACTER(LEN=64)                           ::  pts_id_file = ''  !< namelist parameter
+    CHARACTER(LEN=varnamelength), DIMENSION(50) ::  data_output_pts = ''    !< namelist parameter
 
     INTEGER(iwp) ::  dissipation_classes = 10                     !< namelist parameter (see documentation)
@@ -71,5 +75,5 @@
                                                                   !< prt_count)
     INTEGER(iwp) ::  number_of_particle_groups = 1                !< namelist parameter (see documentation)
-    INTEGER(iwp) ::  part_inc = 1                                 !< increment of particles in output file
+    INTEGER(iwp) ::  pts_increment = 1                            !< increment of particles in output file
 
     INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE ::  prt_count  !< 3d array of number of particles of every grid box
@@ -84,5 +88,5 @@
                                                           !< number)
     REAL(wp) ::  particle_advection_start = 0.0_wp        !< namelist parameter (see documentation)
-    REAL(wp) ::  part_percent = 100.0_wp                  !< percentage of particles in output file
+    REAL(wp) ::  pts_percentage = 100.0_wp                !< percentage of particles in output file
 
     TYPE, PUBLIC ::  particle_type
@@ -115,6 +119,6 @@
     END TYPE particle_type
 
-    TYPE(particle_type), DIMENSION(:), POINTER ::  particles       !< Particle array for this grid cell
-    TYPE(particle_type)                        ::  zero_particle   !< zero particle to avoid weird thinge
+    TYPE(particle_type), DIMENSION(:), POINTER ::  particles      !< Particle array for this grid cell
+    TYPE(particle_type)                        ::  zero_particle  !< zero particle to avoid weird things
 
     TYPE particle_groups_type
@@ -129,9 +133,8 @@
 
     TYPE  grid_particle_def
-        INTEGER(iwp), DIMENSION(0:7)               ::  start_index        !< start particle index for current block
-        INTEGER(iwp), DIMENSION(0:7)               ::  end_index          !< end particle index for current block
-        INTEGER(iwp)                               ::  id_counter         !< particle id counter
-        LOGICAL                                    ::  time_loop_done     !< timestep loop for particle advection
-        TYPE(particle_type), POINTER, DIMENSION(:) ::  particles          !< Particle array for this grid cell
+        INTEGER(iwp), DIMENSION(0:7)               ::  start_index     !< start particle index for current block
+        INTEGER(iwp), DIMENSION(0:7)               ::  end_index       !< end particle index for current block
+        LOGICAL                                    ::  time_loop_done  !< timestep loop for particle advection
+        TYPE(particle_type), POINTER, DIMENSION(:) ::  particles       !< Particle array for this grid cell
     END TYPE grid_particle_def
 
Index: palm/trunk/SOURCE/module_interface.f90
===================================================================
--- palm/trunk/SOURCE/module_interface.f90	(revision 4777)
+++ palm/trunk/SOURCE/module_interface.f90	(revision 4778)
@@ -24,4 +24,7 @@
 ! -----------------
 ! $Id$
+! routine required for output of particle time series added
+!
+! 4768 2020-11-02 19:11:23Z suehring
 ! Enable 3D data output also with 64-bit precision
 !
@@ -399,4 +402,5 @@
                lpm_init,                                                                           &
                lpm_init_arrays,                                                                    &
+               lpm_last_actions,                                                                   &
                lpm_parin,                                                                          &
                lpm_rrd_global,                                                                     &
@@ -2065,5 +2069,5 @@
 
     CALL dynamics_last_actions
-
+    IF ( particle_advection )   CALL lpm_last_actions
     IF ( user_module_enabled )  CALL user_last_actions
 
Index: palm/trunk/SOURCE/shared_memory_io_mod.f90
===================================================================
--- palm/trunk/SOURCE/shared_memory_io_mod.f90	(revision 4777)
+++ palm/trunk/SOURCE/shared_memory_io_mod.f90	(revision 4778)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! additions for output of particle time series
+!
+! 4629 2020-07-29 09:37:56Z raasch
 ! support for MPI Fortran77 interface (mpif.h) removed
 !
@@ -151,5 +154,5 @@
     TYPE, PUBLIC ::  sm_class  !<
 
-       INTEGER(iwp) ::  nr_io_pe_per_node = 2         !< typical configuration, 2 sockets per node
+       INTEGER(iwp) ::  nr_io_pe_per_node             !< typical configuration, 2 sockets per node
        LOGICAL      ::  no_shared_Memory_in_this_run  !<
 
@@ -185,5 +188,5 @@
           PROCEDURE, PASS(this), PUBLIC ::  sm_free_shared
           PROCEDURE, PASS(this), PUBLIC ::  sm_init_comm
-          PROCEDURE, PASS(this), PUBLIC ::  sm_init_part
+          PROCEDURE, PASS(this), PUBLIC ::  sm_init_data_output_particles
           PROCEDURE, PASS(this), PUBLIC ::  sm_node_barrier
 #if defined( __parallel )
@@ -232,4 +235,6 @@
     LOGICAL, INTENT(IN) ::  sm_active  !< flag to activate shared-memory IO
 
+    this%nr_io_pe_per_node = 2
+
     IF ( PRESENT( comm_input ) )  THEN
        this%comm_model = comm_input
@@ -414,7 +419,7 @@
 
 !
-!-- TODO: short description required, about the meaning of the following routine
-!--       part must be renamed particles!
- SUBROUTINE sm_init_part( this )
+!-- Initializing setup for output of particle time series.
+!-- This output always uses a shared memory to reduce the number of particle transfers.
+ SUBROUTINE sm_init_data_output_particles( this )
 
     IMPLICIT NONE
@@ -430,4 +435,6 @@
     LOGICAL :: sm_active  !<
 
+
+    this%nr_io_pe_per_node = 2
 
     sm_active       = .TRUE.   ! particle IO always uses shared memory
@@ -505,5 +512,6 @@
 
        WRITE( *, * ) 'shared_memory_io_mod: internal error'
-       WRITE( *, * ) 'only 2 or 4 shared memory groups per node are allowed'
+       WRITE( *, * ) 'only 1, 2 or 4 shared memory groups per node are allowed '
+       WRITE( *, * ) 'here, ', this%nr_io_pe_per_node, ' groups have been set'
        STOP
 
@@ -540,7 +548,5 @@
 #endif
 
-!    write(9,'(a,8i7)') 'sm_init_comm_part ',this%sh_rank,this%sh_npes,this%io_rank,this%io_npes
-
- END SUBROUTINE sm_init_part
+ END SUBROUTINE sm_init_data_output_particles
 
 !--------------------------------------------------------------------------------------------------!
